
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  Gold
#property indicator_color2  DodgerBlue
#property indicator_color3  HotPink
#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_DOT
#property indicator_style3 STYLE_DOT


extern double ATRFactor = 2.0; 
extern int ATRPeriod = 50;
extern int MAPeriod = 50;
extern int MAMethod = MODE_SMA;


double MA[];
double HiAdjBuffer[];
double LoAdjBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//--- indicator buffers mapping
   SetIndexBuffer(0,MA);         // Assigning an array to a buffer
   SetIndexBuffer(1,HiAdjBuffer);         // Assigning an array to a buffer
   SetIndexBuffer(2,LoAdjBuffer);         // Assigning an array to a buffer

   IndicatorDigits(Digits);
   SetIndexLabel(0, "MA");
   SetIndexLabel(1, "Upper Limit");
   SetIndexLabel(2, "Lower Limit");

   return(INIT_SUCCEEDED);
}

int start()                         // Special function start()
{
   int i,                           // Bar index
       Counted_bars;                // Number of counted bars
//--------------------------------------------------------------------
   Counted_bars=IndicatorCounted(); // Number of counted bars
   i=Bars-Counted_bars-1;           // Index of the first uncounted
   while(i>=0)                      // Loop for uncounted bars
   {
     
      MA[i] = iMA(NULL,0,MAPeriod,0,MAMethod,PRICE_CLOSE,i);
      double ATRShift  = ATRFactor*iATR(NULL,0,ATRPeriod,i);
      
      HiAdjBuffer[i] = MA[i] + ATRShift;
                           
      LoAdjBuffer[i] = MA[i] - ATRShift;
      i--;                         
   }
//--------------------------------------------------------------------
   return (0);                          // Exit the special funct. start()
}
//+------------------------------------------------------------------+
